```
(define (p) (p))

(define (test x y) 
  (if (= x 0) 
	  0 
	  y))

(test 0 (p))
```
Under normal order evaluation, `(test 0 (p))` would just return `0`, since `if` checks the value of `x` and if it's `0`, it returns it and quits, never bothering with checking `y`.

Under applicative order evaluation, the program will hang without returning anything, because it will try to evaluate (p), which points to itself, making a loop.